function addProp(img, x, y, r)
	local i = propList.imgs[img]
	table.insert(propTable, {
		x = x, y = y, r = r, 
		w = i:getWidth(),
		h = i:getHeight(),

		xx = function(self)
			return self.x - self.w * 0.5
		end,
		yy = function(self)
			return self.y - self.h * 0.5
		end,

		type = "prop", -- type prop does not interact with npcs; push does
		ttype = "movable",

		background = true, -- if false, it will draw above everything

		img = img,
		scale = 1,

		hueCycle = false,
	})
end

function addEnemy(img, x, y)
	table.insert(enemyTable, {
		x = x,
		y = y,
		w = 24,
		h = 24,

		xx = function(self)
			return self.x - self.w * 0.5
		end,
		yy = function(self)
			return self.y - self.h * 0.5
		end,

		r = 0,
		img = img,
		path = {},
		mode = "patrol", -- or "stand"
		loop = "reverse", -- or "circle"
		weapon = "knife", -- nil gun means knife only
	})
end

guns = {
	["knife"] = 1,
	["pistol"] = 2,
	["auto"] = 3,
	["shotgun"] = 4,

	[1] = "knife",
	[2] = "pistol",
	[3] = "auto",
	[4] = "shotgun",
}