local holdSound
function stopAbilitySound()
	if holdSound then stopSound("holdTeleport", holdSound); holdSound = nil end
end

function ability(state) -- state is either p or r - pressed or released
	if not player.abilityInv[player.abilitySelected] then return end
	
	local s = player.abilityInv[player.abilitySelected][1]
	local x, y = camera:mousePosition()

	if s == "spatial dilation" then
		if state == "p" then
			holdSound = playSound("holdTeleport")
		end

		if state == "r" then
			if triggers.dtMult ~= 1 then triggers.dtMult = 1 end
			stopAbilitySound()

			local vv = player.abilityInv[player.abilitySelected][2]
			if vv and world:hasItem(vv) then
				world:update(player, vv:xx(), vv:yy())
				world:update(vv, player:xx(), player:yy())

				local ox, oy = player.x, player.y
				player.x, player.y = vv.x, vv.y
				vv.x, vv.y = ox, oy

				player.abilityDrain = player.abilityDrain + 0.6
				playSound("teleport")

				en.stun(vv, 1.5)
			elseif canUseAbility(s) then
				local mx, my = x - player.w * 0.5, y - player.h * 0.5
				local _, len = world:queryRect(mx, my, player.w, player.h, function(item) return item.type == "wall" or item.type == "push" end)

				if len == 0 then
					world:update(player, mx, my)

					player.abilityDrain = player.abilityDrain + 0.25
					playSound("teleport")

					player.x = x
					player.y = y
				end
			end

			if player.abilityDrain >= 1 then
				killPlayer(player, 0, 0)
			end
		end

		player.abilityInv[player.abilitySelected][2] = nil
	elseif s == "psyche wall" then
		if state == "p" then
			player.abilityInv[player.abilitySelected][2] = true
			holdSound = playSound("holdTeleport")
		elseif state == "r" then
			if triggers.dtMult ~= 1 then triggers.dtMult = 1 end
			player.abilityInv[player.abilitySelected][2] = false
			stopAbilitySound()

			addExplosion(player.x, player.y, 150, true)
			playSound("shield")
			for i,v in ipairs(enemies) do
				if math.dist(player.x, player.y, v.x, v.y) <= 150 then
					en.stun(v, 2)
					local ang = math.angle(player.x, player.y, v.x, v.y)
					v.v = {
						x = math.cos(ang) * 500,
						y = math.sin(ang) * 500,
					}

					flux.to(v.v, 1, {x = 0, y = 0}):ease("quartout")
				end
			end
		end
	end
end

function canUseAbility(s)
	if s == "spatial dilation" then
		local x, y = camera:mousePosition()
		local dist = math.dist(player.x, player.y, x, y)
		return dist < 150
	end
end