local particles = {}
local pImg = love.graphics.newImage("img/misc/part.png")
function newParticle(x, y, s, r, v, t)
	local i = {
		x = x,
		y = y,
		s = s,      -- Size
		r = 0,
		rr = r,		-- Rotation factor
		v = v,      -- Movement vector
		t = t,    	-- Life span
	}

	table.insert(particles, i)
end

function updateParticles(dt)
	for i,v in ipairs(particles) do
		v.t = v.t - dt
		v.r = v.r + v.rr * dt

		if v.t <= 0 then
			table.remove(particles, i)
		else
			v.x = v.x + math.cos(v.v[1]) * v.v[2] * dt
			v.y = v.y + math.sin(v.v[1]) * v.v[2] * dt

			local p = player
			local dist = math.dist(v.x, v.y, p.x, p.y)
			if dist <= (28) then
				local ang = math.angle(p.x, p.y, v.x, v.y)
				v.x = math.cos(ang) * 28 + p.x
				v.y = math.sin(ang) * 28 + p.y
				break;
			end
		end
	end
end

function drawParticles()
	for i,v in ipairs(particles) do
		love.graphics.draw(pImg, v.x, v.y, v.r, v.s, v.s, pImg:getWidth() * 0.5, pImg:getHeight() * 0.5)
	end
end

function wipeParticles()
	particles = {}
end